#include <errno.h>
#include <osbind.h>
#include <stddef.h>
#include <assert.h>
#include <ctype.h>
#include <limits.h>
#include <unistd.h>
#include <string.h>
#include "lib.h"

/***************************************************************
chdir: change the directory and (possibly) the drive.
By ERS: it's in the public domain.
****************************************************************/

int __chdir(dir)
const char *dir;
{
	int drv, old;
	int r;
	char tmp[PATH_MAX];
	register char *d;

	assert ((dir != NULL));

	/* We can't simply use the user supplied buffer because we may
	   write into the buffer.  */
	if (!__libc_unix_names)
	  (void)_unx2dos(dir, tmp, sizeof (tmp));	/* convert Unix filename to DOS */
	else
	  strcpy (tmp, dir);

	d = tmp;
	old = Dgetdrv();
	if (*d && *(d+1) == ':') {
		drv = toupper(*d) - 'A';
		d+=2;
		(void)Dsetdrv(drv);
	}

	if (!*d) {		/* empty path means root directory */
		*d = '\\';
		*(d+1) = '\0';
	}
	if ((r = Dsetpath(d)) < 0) {
		(void)Dsetdrv(old);
		if ((r == -EPATH) && _enoent(tmp)) {
			r = -ENOENT;
		}
		errno = -r;
		return -1;
	}
	return 0;
}

#ifdef HAVE_WEAK_SYMBOLS
weak_alias (__chdir, chdir)
#endif
