/*  exit.c -- MiNTLib.
    Copyright (C) 1999 Guido Flohr <gufl0000@stud.uni-sb.de>

    This file is part of the MiNTLib project, and may only be used
    modified and distributed under the terms of the MiNTLib project
    license, COPYMINT.  By continuing to use, modify, or distribute
    this file you indicate that you have read the license and
    understand and accept it fully.
*/

#include <stdio.h>

#ifndef HAVE_WEAK_SYMBOLS
# define ___fclose_all_file _fclose_all_files
# define __exit exit
#endif

/* Functions registered by user for calling at exit.  */
typedef void (*ExitFn) __PROTO ((void));
__EXTERN ExitFn *_at_exit;
extern int _num_at_exit;	/* Number of functions registered - 1.  */

#if __GNUC__ > 1
/* In libgcc.a.  */
__EXTERN void __do_global_dtors __PROTO ((void));
#endif

void
___fclose_all_files ()
{
  register int i, f;

  for(i = 0; i < _NFILE; ++i) 
    {
      f = _iob[i]._flag;
      if (f & (_IORW | _IOREAD | _IOWRT)) 
        {
	  if (_iob[i]._file <= 2) 
	    {  /* Flush std. streams only.  */
	      fflush (&_iob[i]);
	    }
          else 
            {
	      fclose (&_iob[i]);
	    }
        }
    }
}
#ifdef HAVE_WEAK_SYMBOLS
weak_alias (___fclose_all_files, _fclose_all_files)
#endif

__EXITING __exit (status)
  int status;
{
  register int i;

  for(i = _num_at_exit - 1; i >= 0; --i)
    (*_at_exit[i]) ();

#if __GNUC__ > 1
  __do_global_dtors ();
#endif

  ___fclose_all_files();
  _exit(status);
}
#ifdef HAVE_WEAK_SYMBOLS
weak_alias (__exit, exit)
#endif
