/*  tmpnam.c -- MiNTLib.
    Copyright (C) 1999 Guido Flohr <gufl0000@stud.uni-sb.de>

    This file is part of the MiNTLib project, and may only be used
    modified and distributed under the terms of the MiNTLib project
    license, COPYMINT.  By continuing to use, modify, or distribute
    this file you indicate that you have read the license and
    understand and accept it fully.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

__EXTERN const char* __get_tmpdir __PROTO ((const char*));

static char def_buf[L_tmpnam];
extern int __mint;

char* tmpnam (user_buf)
     char* user_buf;
{
  char* tmpdir = (char*) __get_tmpdir (NULL);  /* Cannot fail!  */
  char* buf = user_buf == NULL ? def_buf : user_buf;
  size_t len = strlen (tmpdir);
  
  memcpy (buf, tmpdir, len);
  if (buf[len - 1] != '/' && buf[len - 1] != '\\')
    {
      if (__mint)
        buf[len] = '/';
      else
        buf[len] = '\\';
      len++;
    }
  memcpy (buf + len, "XXXXXX\000", 7);
  return mktemp (buf);
}
